#ifdef __cplusplus
extern "C" {
#endif

#ifndef _atomparser_h
#define _atomparser_h

typedef struct {
	char artist[256];
	char album[256];
	char title[256];
	char genrename[32];
	int genrenum;
	char cgen[64];
	char year[8];
	char comment[256];
	char tool[256];
	char writer[256];
	int track;
	int cpil;
	int tmpo;
	int disk;
	int channels;
	int sample_rate;
	char codec[64];
	int mdatsize;
	int playtime;  
} Song;

typedef struct {
	char name[5];
	int size;
	int pos;
	int level;
} Atom;

typedef struct {
	Atom **atoms;
	int entries;
	Song tag;
	unsigned int moovpos;
	unsigned int udtapos;
	unsigned int udtasize;
	unsigned int freepos;
	unsigned int freesize;
} FileInfo;

int GenreNumToString (char* GenreStr, const int GenreNum);
int GenreStringtoNum(char *gnre);
int strpos2(const char *s, const char c, int n);
int strstr2(const char *s1, const char *s2, int ns1);
unsigned int OneByte(const char *data);
char *TimeString(int seconds);
void ParseTag(char *key, char *data, int size, Song *tag);
void PrintTag(Song *tag);
void PrintAtom(Atom *atom);
void stsd(Song *tag, char *atomdata);
int ParseAtom(FILE *f, unsigned int firstOff, unsigned int stopAt, FileInfo *fileinfo);
void FreeFileInfo(FileInfo *fileinfo);

#endif

#ifdef __cplusplus
}
#endif

